﻿using ProjectByldozer.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectByldozer.Drawnings;

public class DrawiningTrackedCarEqutables : IEqualityComparer<DrawningTrackedCar?>
{
    public bool Equals(DrawningTrackedCar? x, DrawningTrackedCar? y)
    {
        if (x == null || x.EntityTrackedCar == null)
        {
            return false;
        }
        if (y == null || y.EntityTrackedCar == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityTrackedCar.Speed != y.EntityTrackedCar.Speed)
        {
            return false;
        }
        if (x.EntityTrackedCar.Weight != y.EntityTrackedCar.Weight)
        {
            return false;
        }
        if (x.EntityTrackedCar.BodyColor != y.EntityTrackedCar.BodyColor)
        {
            return false;
        }
        if (x is DrawningByldozer && y is DrawningByldozer)
        {
            EntityByldozer _x = (EntityByldozer)x.EntityTrackedCar;
            EntityByldozer _y = (EntityByldozer)x.EntityTrackedCar;
            if (_x.AdditionalColor != _y.AdditionalColor)
            {
                return false;
            }
            if (_x.Dump != _y.Dump)
            {
                return false;
            }
            if (_x.Bakingpowder != _y.Bakingpowder)
            {
                return false;
            }
            if (_x.Pipe != _y.Pipe)
            {
                return false;
            }
        }
        return true;
    }
    public int GetHashCode([DisallowNull] DrawningTrackedCar obj)
    {
        return obj.GetHashCode();
    }
}
