﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectByldozer.Drawnings
{
    public class DrawningTrackedCarCompareByType : IComparer<DrawningTrackedCar?>
    {
        public int Compare(DrawningTrackedCar? x, DrawningTrackedCar? y)
        {
            if (x == null || x.EntityTrackedCar == null)
            {
                return 1;
            }

            if (y == null || y.EntityTrackedCar == null)
            {
                return -1;
            }

            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }

            var speedCompare = x.EntityTrackedCar.Speed.CompareTo(y.EntityTrackedCar.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityTrackedCar.Weight.CompareTo(y.EntityTrackedCar.Weight);
        }
    }
}
